<?xml version="1.0" encoding="UTF-8"?>
<!--
  ~ Copyright (c) Aeontronix 2021
  -->

<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <parent>
        <groupId>com.aeontronix.enhanced-mule</groupId>
        <artifactId>enhanced-mule-tools</artifactId>
        <version>1.4.9-SNAPSHOT</version>
    </parent>
    <modelVersion>4.0.0</modelVersion>

    <artifactId>enhanced-mule-tools-cli</artifactId>
    <name>Enhanced Mule Tools: Command Line</name>

    <dependencies>
        <dependency>
            <groupId>com.aeontronix.enhanced-mule</groupId>
            <artifactId>enhanced-mule-tools-lib</artifactId>
            <version>1.4.9-SNAPSHOT</version>
        </dependency>
        <dependency>
            <groupId>com.aeontronix.aeon-commons</groupId>
            <artifactId>aeon-commons-logging</artifactId>
            <version>2.0.0-beta5</version>
        </dependency>
        <dependency>
            <groupId>org.slf4j</groupId>
            <artifactId>slf4j-jdk14</artifactId>
            <!--suppress MavenPackageUpdate -->
            <version>1.7.36</version>
        </dependency>
        <!--        &lt;!&ndash; Maven Embedded &ndash;&gt;
                <dependency>
                    <groupId>org.apache.maven</groupId>
                    <artifactId>maven-embedder</artifactId>
                    <version>3.6.3</version>
                </dependency>
                <dependency>
                    <groupId>org.apache.maven</groupId>
                    <artifactId>maven-compat</artifactId>
                    <version>3.6.3</version>
                </dependency>-->
    </dependencies>

    <build>
        <plugins>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-shade-plugin</artifactId>
                <version>3.2.4</version>
                <executions>
                    <execution>
                        <phase>package</phase>
                        <goals>
                            <goal>shade</goal>
                        </goals>
                        <configuration>
                            <transformers>
                                <transformer
                                        implementation="org.apache.maven.plugins.shade.resource.ManifestResourceTransformer">
                                    <manifestEntries>
                                        <Main-Class>com.aeontronix.enhancedmule.tools.cli.Main</Main-Class>
                                    </manifestEntries>
                                </transformer>
                            </transformers>
                            <filters>
                                <filter>
                                    <artifact>com.fasterxml.jackson.dataformat:jackson-dataformat-yaml</artifact>
                                    <excludes>
                                        <exclude>META-INF/services/com.fasterxml.jackson.core.JsonFactory</exclude>
                                        <exclude>META-INF/services/com.fasterxml.jackson.core.ObjectCodec</exclude>
                                    </excludes>
                                </filter>
                                <filter>
                                    <artifact>*:*</artifact>
                                    <excludes>
                                        <exclude>META-INF/*.SF</exclude>
                                        <exclude>META-INF/*.DSA</exclude>
                                        <exclude>META-INF/*.RSA</exclude>
                                        <exclude>META-INF/MANIFEST.MF</exclude>
                                    </excludes>
                                </filter>
                            </filters>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <artifactId>maven-assembly-plugin</artifactId>
                <version>3.1.0</version>
                <executions>
                    <execution>
                        <id>jar-with-dependencies</id>
                        <phase>package</phase>
                        <goals>
                            <goal>single</goal>
                        </goals>
                        <configuration>
                            <descriptors>
                                <descriptor>src/main/assembly/assembly.xml</descriptor>
                            </descriptors>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>com.akathist.maven.plugins.launch4j</groupId>
                <artifactId>launch4j-maven-plugin</artifactId>
                <executions>
                    <execution>
                        <id>l4j-clui</id>
                        <phase>package</phase>
                        <goals><goal>launch4j</goal></goals>
                        <configuration>
                            <headerType>console</headerType>
                            <outfile>target/emt.exe</outfile>
                            <jar>target/${project.artifactId}-${project.version}.jar</jar>
                            <errTitle>emt</errTitle>
                            <classPath>
                                <mainClass>com.aeontronix.enhancedmule.tools.cli.Main</mainClass>
                            </classPath>
                            <jre>
                                <minVersion>1.8.0</minVersion>
                                <path>jre</path>
                                <bundledJre64Bit>true</bundledJre64Bit>
                                <bundledJreAsFallback>true</bundledJreAsFallback>
                                <runtimeBits>64/32</runtimeBits>
                            </jre>
                            <versionInfo>
                                <fileVersion>1.0.0.0</fileVersion>
                                <txtFileVersion>1.0.0.0</txtFileVersion>
                                <fileDescription>Enhanced Mule Tools</fileDescription>
                                <copyright>Copyright Aeontronix 2020</copyright>
                                <productVersion>1.0.0.0</productVersion>
                                <txtProductVersion>1.0.0.0</txtProductVersion>
                                <productName>Enhanced Mule Tools</productName>
                                <internalName>emt</internalName>
                                <originalFilename>emt-orig.exe</originalFilename>
                            </versionInfo>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>org.codehaus.mojo</groupId>
                <artifactId>build-helper-maven-plugin</artifactId>
                <version>3.2.0</version>
                <executions>
                    <execution>
                        <id>attach-artifacts</id>
                        <phase>package</phase>
                        <goals>
                            <goal>attach-artifact</goal>
                        </goals>
                        <configuration>
                            <artifacts>
                                <artifact>
                                    <file>target/emt.exe</file>
                                    <type>exe</type>
                                </artifact>
                            </artifacts>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
        </plugins>
    </build>
</project>
